// -*- C++ -*-
/*!
 * @file StringIn.cpp
 * @brief Sample string in component
 * @date $Date: 2005/05/12 09:06:20 $
 *
 * $Id: StringIn.cpp,v 1.1.1.1 2005/05/12 09:06:20 n-ando Exp $
 */



#include "StringIn.h"
#ifndef WIN32
#include <unistd.h>
#endif
#include <iostream>
#include <string>

using namespace std;

StringIn::StringIn(RtcManager* manager)
  : RtcBase(manager) ,
    m_string_inIn("string_in", m_string_in)

{
  registerInPort(m_string_inIn);
  appendAlias("/example/StringIn|rtc");
}

/*
RtmRes StringIn::rtc_init_entry()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_ready_entry()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_ready_do()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_ready_exit()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_starting_entry()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_active_entry()
{
  return RTM_OK;
}
*/




RtmRes StringIn::rtc_active_do()
{
#ifdef WIN32
  while (!m_string_inIn.isNew()) Sleep(100);
#else
  while (!m_string_inIn.isNew()) usleep(100000);
#endif
  m_string_inIn.read();
  std::cout << m_string_in.data << std::endl;
  return RTM_OK;
}




/*
RtmRes StringIn::rtc_active_exit()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_stopping_entry()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_aborting_entry()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_error_entry()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_error_do()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_error_exit()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_fatal_entry()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_fatal_do()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_fatal_exit()
{
  return RTM_OK;
}
*/



/*
RtmRes StringIn::rtc_exiting_entry()
{
  return RTM_OK;
}
*/



extern "C" {
  
  RtcBase* StringInNew(RtcManager* manager)
  {
	return new StringIn(manager);
  }
  
  
  void StringInDelete(RtcBase* p)
  {
	delete (StringIn *)p;
	return;
  }
  
  
  void StringInInit(RtcManager* manager)
  {
	RtcModuleProfile profile(stringin_spec);
	manager->registerComponent(profile, StringInNew, StringInDelete);
  }
};

