#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-
#

import re
import os
import time
import random, md5

class VCProject:
	def __init__(self, fname, spec):
		self.fname = fname
		self.vc_fname = fname + ".vcproj"
		self.spec = spec
		self.version = os.popen("rtm-config --version", "r").read()
		self.vc_version = "7.10"
		
	def print_vcproject(self):
		if (not self.check_overwrite(self.vc_fname)):
			return
		vcproj = file(self.vc_fname, "w")

		print >> vcproj, """<?xml version="1.0" encoding="shift_jis"?>"""
		
		print >> vcproj, """<VisualStudioProject
	ProjectType="Visual C++"
	Version="%s"
	Name="%s"
	ProjectGUID="%s"
	Keyword="Win32Proj">
	<Platforms>
	<Platform
		Name="Win32"/>
	</Platforms>
""" % (self.vc_version,
		self.fname,
		self.guid())


		print >> vcproj, """	<Configurations>
		<Configuration
			Name="Debug|Win32"
			OutputDirectory="Debug"
			IntermediateDirectory="Debug"
			ConfigurationType="1"
			CharacterSet="0"
			ReferencesPath="">
			<Tool
				Name="VCCLCompilerTool"
				AdditionalOptions="/Ob0"
				Optimization="0"
				AdditionalIncludeDirectories="&quot;$(RTM_ROOT)\\x86_include&quot;;&quot;$(RTM_ROOT)\\x86_include\\rtm&quot;;&quot;$(RTM_ROOT)\\x86_include\\rtm\\idl&quot;;&quot;$(ACE_ROOT)\\&quot;;&quot;$(OMNI_ROOT)\\include\\&quot;"
				PreprocessorDefinitions="USE_stub_in_nt_dll;WIN32;_DEBUG;_CONSOLE;__WIN32__;__x86__;_WIN32_WINNT=0x0400;__NT__;__OSVERSION__=4"
				MinimalRebuild="TRUE"
				BasicRuntimeChecks="3"
				RuntimeLibrary="3"
				RuntimeTypeInfo="TRUE"
				UsePrecompiledHeader="0"
				WarningLevel="3"
				Detect64BitPortabilityProblems="FALSE"
				DebugInformationFormat="4"/>
			<Tool
				Name="VCCustomBuildTool"/>
			<Tool
				Name="VCLinkerTool"
				AdditionalDependencies="libRTCd.lib ace.lib"
				OutputFile="$(OutDir)/$(ProjectName)Comp.exe"
				LinkIncremental="2"
				AdditionalLibraryDirectories="&quot;$(RTM_ROOT)\\x86_bin&quot;;&quot;$(ACE_ROOT)\\ace\\&quot;"
				IgnoreDefaultLibraryNames="libcmtd"
				GenerateDebugInformation="TRUE"
				ProgramDatabaseFile="$(OutDir)/$(ProjectName)d.pdb"
				SubSystem="1"
				TargetMachine="1"/>
			<Tool
				Name="VCMIDLTool"/>
			<Tool
				Name="VCPostBuildEventTool"/>
			<Tool
				Name="VCPreBuildEventTool"/>
			<Tool
				Name="VCPreLinkEventTool"/>
			<Tool
				Name="VCResourceCompilerTool"/>
			<Tool
				Name="VCWebServiceProxyGeneratorTool"/>
			<Tool
				Name="VCXMLDataGeneratorTool"/>
			<Tool
				Name="VCWebDeploymentTool"/>
			<Tool
				Name="VCManagedWrapperGeneratorTool"/>
			<Tool
				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
		</Configuration>
		<Configuration
			Name="Release|Win32"
			OutputDirectory="Release"
			IntermediateDirectory="Release"
			ConfigurationType="1"
			CharacterSet="0">
			<Tool
				Name="VCCLCompilerTool"
				AdditionalIncludeDirectories="&quot;$(RTM_ROOT)\\x86_include&quot;;&quot;$(RTM_ROOT)\\x86_include\\rtm&quot;;&quot;$(RTM_ROOT)\\x86_include\\rtm\\idl&quot;;&quot;$(ACE_ROOT)\\&quot;;&quot;$(OMNI_ROOT)\\include\\&quot;"
				PreprocessorDefinitions="USE_stub_in_nt_dll;WIN32;NDEBUG;_CONSOLE;__WIN32__;__x86__;_WIN32_WINNT=0x0400;__NT__;__OSVERSION__=4"
				RuntimeLibrary="2"
				RuntimeTypeInfo="TRUE"
				UsePrecompiledHeader="0"
				WarningLevel="3"
				Detect64BitPortabilityProblems="FALSE"
				DebugInformationFormat="3"/>
			<Tool
				Name="VCCustomBuildTool"/>
			<Tool
				Name="VCLinkerTool"
				AdditionalDependencies="libRTC.lib ace.lib"
				OutputFile="$(OutDir)/$(ProjectName)Comp.exe"
				LinkIncremental="0"
				AdditionalLibraryDirectories="&quot;$(RTM_ROOT)\\x86_bin&quot;;&quot;$(ACE_ROOT)\\ace\\&quot;"
				IgnoreDefaultLibraryNames="libc"
				SubSystem="1"
				OptimizeReferences="2"
				EnableCOMDATFolding="2"
				TargetMachine="1"/>
			<Tool
				Name="VCMIDLTool"/>
			<Tool
				Name="VCPostBuildEventTool"/>
			<Tool
				Name="VCPreBuildEventTool"/>
			<Tool
				Name="VCPreLinkEventTool"/>
			<Tool
				Name="VCResourceCompilerTool"/>
			<Tool
				Name="VCWebServiceProxyGeneratorTool"/>
			<Tool
				Name="VCXMLDataGeneratorTool"/>
			<Tool
				Name="VCWebDeploymentTool"/>
			<Tool
				Name="VCManagedWrapperGeneratorTool"/>
			<Tool
				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
		</Configuration>
	</Configurations>
	<References>
	</References>
	<Files>
		<Filter
			Name="source file"
			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
			UniqueIdentifier="%s">
			<File
				RelativePath=".\\%s.cpp">
			</File>
			<File
				RelativePath=".\\%sComp.cpp">
			</File>
		</Filter>
		<Filter
			Name="header file"
			Filter="h;hpp;hxx;hm;inl;inc;xsd"
			UniqueIdentifier="%s">
			<File
				RelativePath=".\\%s.h">
			</File>
		</Filter>
		<Filter
			Name="resource file"
			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx"
			UniqueIdentifier="%s">
		</Filter>
	</Files>
	<Globals>
	</Globals>
</VisualStudioProject>
""" % (self.guid(),self.fname,self.fname,self.guid(),self.fname,self.guid())

		print self.vc_fname, "was generated"

	def check_overwrite(self, fname):
		if (os.access(fname, os.F_OK)):
			ans = raw_input("\"" + fname + "\" already exists. Overwrite? (y/n) ")
			if (ans == "y" or ans == "Y"):
				return True
			else:
				return False
		else:
			return True

	def guid(self):
		"""
    Generates a universally unique ID.
    Any arguments only create more randomness.
"""
		try:
			import pythoncom
			return str(pythoncom.CreateGuid())
		except:
			args = " "
			t = long( time.time() * 1000 )
			r = long( random.random()*100000000000000000L )
			try:
				a = socket.gethostbyname( socket.gethostname() )
			except:
				# if we can't get a network address, just imagine one
				a = random.random()*100000000000000000L
			data = str(t)+' '+str(r)+' '+str(a)+' '+str(args)
			data = md5.md5(data).hexdigest().upper()
			guid = "{" + data[0:8] + \
				 "-" + data[8:12] + \
				 "-" + data[12:16] + \
				 "-" + data[16:20] + \
				 "-" + data[20:] + "}"
			return guid

def main():
	module_spec = {"module-name":["RTC_MODULE_NAME","Hoge"],
			   "module-desc":["RTC_MODULE_DESC","Hoge component"],
			   "module-version":["RTC_MODULE_VERSION","0.1"],
			   "module-author":["RTC_MODULE_AUTHOR","Hoge"],
			   "module-category":["RTC_MODULE_CATEGORY","Generic"],
			   "module-comp-type":["RTC_MODULE_COMP_TYPE","COMMUTATIVE"],
			   "module-act-type":["RTC_MODULE_ACT_TYPE","SPORADIC"],
			   "module-max-inst":["RTC_MODULE_MAX_INST","10"],
			   "module-lang":["RTC_MODULE_LANG","C++"],
			   "module-inport":["", {"Ref":"TimedFloat", \
									"Sens":"TimedDouble"}],
			   "module-outport":["", {"Ctrl":"TimedFloat", \
									 "Monitor":"TimedShort"}]
			   }

	vcproj = VCProject("HogeTest", module_spec)
	vcproj.print_vcproject()


if __name__ == "__main__":
	main()
